<?php
function Security($text){
    $text = mb_strtolower($text);
    $forbiddenWords = array('api_key', 'token_bots', 'update', 'getme', 'include', 'foreach', 'input', 'exec', 'json', 'curl', 'php', 'zip', 'Archive', 'function', '#', '\'', '$', '"', '(', ')', '[', ']',"'",'}','{');
    foreach($forbiddenWords as $word) {
        if(strpos($text, $word) !== false) {
            return 'ok';
        }
    }
}
if(!isset($_GET['region']) or !isset($_GET['id']) or !isset($_GET['time']) or !isset($_GET['type'])) exit;

if(Security($_GET['region']) == 'ok' or Security($_GET['id']) == 'ok' or Security($_GET['time']) == 'ok' or Security($_GET['type']) == 'ok') exit();


$region = $_GET['region'];
$type = $_GET['type'];
if(!in_array($type,["cpu","network","disk"])) exit;
if(!in_array($region,["ir","sw","uk"])) exit;
function region(){
    global $region;
    switch($region){
        case 'ir':
            return 'IuLzryIFBE6hh2JwF32TJVbDRdHVsUmm6fbdbyb2gefVIOUbV8mMu99M6Oc8WseO';
        case 'uk':
            return 'WwT6DFtCnC2WGC2KIcVoZUBfz3WFDel3zEnmpt8wFYAjGjpceRMN9stXD4TuNgA5';
        case 'sw':
            return 'O4AX7JGGJEzczfGyyRcSURi6tNuiK3wczvmOInWGeqsecpdFV78wIY75Ew34QMpy';
        default:
            return false;
    }
}
$token = region();
if(!isset($token)) exit;

if(preg_match('/^[0-9]*$/', $_GET['id'])) {
    $server_id = $_GET['id'];
}else{
    exit;
}

$timer = $_GET['time'];
if($timer < 1 and $timer > 30) exit;
if(!preg_match('/^[0-9]*$/', $timer)) exit;
$currentDate = date('Y-m-d');
$start_date = new DateTime($currentDate);
$start_date->modify("-$timer days");



$currentDate = date('Y-m-d');
$currentDateTime = new DateTime($currentDate);
$end_date = new DateTime($currentDateTime->format('Y-m-d'));

$end_date = $end_date->format('Y-m-d');

$start_date = $start_date->format('Y-m-d');
$url = "https://api.hetzner.cloud/v1/servers/{$server_id}/metrics?type=$type&start={$start_date}&end={$end_date}";

$ch = curl_init($url);

$headers = [
    "Authorization: Bearer $token"
];
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($ch);

curl_close($ch);

$data = json_decode($response, true);

$labels = [];
$network_data = [];

foreach ($data['metrics']['time_series'] as $key => $value) {
    $labels[] = $key;
    $network_data[$key] = array_column($value['values'], 1);
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Metrics</title>
    <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
</head>
<body>
    <div id="chart"></div>
    <button onclick="downloadImage()">ذخیره تصویر</button>

    <script>
        var data = <?php echo json_encode($network_data); ?>;
        var labels = <?php echo json_encode($labels); ?>;

        var traces = [];

        for (var label in data) {
            traces.push({
                x: Array.from({length: data[label].length}, (_, i) => i),
                y: data[label],
                mode: 'lines',
                name: label
            });
        }

        var layout = {
            title: 'Metrics',
            xaxis: {
                title: 'Time'
            },
            yaxis: {
                title: 'Value'
            }
        };

        Plotly.newPlot('chart', traces, layout);

        function downloadImage() {
            Plotly.downloadImage('chart', {
                format: 'png',
                filename: 'image',
                height: 600,
                width: 800
            });
        }
    </script>
</body>
</html>
