<?php
$response = '{"status":"success","data":{"resultType":"matrix","result":[{"metric":{"direction":"inbound","host_id":"415737850","interface":"public"},"values":[[1714401360,"140.60873801678434"],[1714401480,"167.7941228190991"]]}]}}';
$data = json_decode($response, true);

$labels = [];
$network_data = [];

foreach ($data['data']['result'] as $result) {
    $label = $result['metric']['interface'];
    $values = array_map(function($value) {
        return [$value[0] * 1000, (float) $value[1]];
    }, $result['values']);
    $labels[] = $label;
    $network_data[$label] = $values;
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Metrics</title>
    <script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
</head>
<body>
    <div id="chart"></div>
    <button onclick="downloadImage()">ذخیره تصویر</button>

    <script>
        var data = <?php echo json_encode($network_data); ?>;
        var labels = <?php echo json_encode($labels); ?>;

        var traces = [];

        for (var label in data) {
            traces.push({
                x: data[label].map(function(value) { return new Date(value[0]); }),
                y: data[label].map(function(value) { return value[1]; }),
                mode: 'lines',
                name: label
            });
        }

        var layout = {
            title: 'Metrics',
            xaxis: {
                title: 'Time'
            },
            yaxis: {
                title: 'Value'
            }
        };

        Plotly.newPlot('chart', traces, layout);

        function downloadImage() {
            Plotly.downloadImage('chart', {
                format: 'png',
                filename: 'image',
                height: 600,
                width: 800
            });
        }
    </script>
</body>
</html>